<template>
  <div class="d-flex flex-column">
    <span>Заполните 4 варианта и выберите правильный ответ:</span>
    <div v-for="(item, index) in variants" :key="index" class="question-item">
      <ValidationProvider
        style="width: 100%"
        :name="`question-${index}`"
        rules="required"
        v-slot="{ errors }"
      >
        <v-text-field
          :value="item.question"
          @input="onQuestionChange(index, $event)"
          :label="`Вопрос: ${index + 1}`"
          :error-messages="errors"
        ></v-text-field>
      </ValidationProvider>
      <ValidationProvider
        style="width: 100%"
        :name="`answer-${index}`"
        rules="required"
        v-slot="{ errors }"
      >
        <v-text-field
          :value="item.answer"
          @input="onAnswerChange(index, $event)"
          :label="`Ответ: ${index + 1}`"
          :error-messages="errors"
        ></v-text-field>
      </ValidationProvider>
    </div>
    <v-btn @click="addVariant" color="purple" class="d-flex"
      >Добавить вариант</v-btn
    >
  </div>
</template>
<script>
import QuestionMixin from "@/mixins/Question.js";
import { extend } from "vee-validate";
import { required } from "vee-validate/dist/rules";

const CONTROL_SETTINGS = {};

export default {
  mixins: [QuestionMixin],
  created() {
    extend("radio", {
      ...required,
      message: "Поле не может быть пустым"
    });
  },
  data() {
    return {
      variants: this.value || [],
    };
  },
  watch: {
    variants: {
      deep: true,
      handler(v) {
        debugger
        this.innerConfig.result = v
        this.innerConfig = { ...this.innerConfig}
      }
    }
  },
  computed: {
    variantsSchema() {
      return this.variants.map(item => {});
    }
  },
  methods: {
    addVariant() {
      const tmp = {
        question: "",
        answer: "",
        id: this.variants.length
      };
      this.variants = [...this.variants, tmp];
    },
    onQuestionChange(idx, value) {
      this.$set(this.variants, idx, { ...this.variants[idx], question: value })
    },
    onAnswerChange(idx, value) {
      this.$set(this.variants, idx, { ...this.variants[idx], answer: value })
    },
  }
};
</script>